#ifndef KANJI_UNION_H
#define KANJI_UNION_H

#ifdef __BORLANDC__
#pragma warn -8004
#pragma warn -8012
#endif

#define VERSION_NUMBER 1.04
#define BLOCK_SIZE 2560
#define BUFFER_SIZE 3712 /* strcpy(buffer, getenv("Path") ); */
#define COMBO_SIZE 39424
#define C_SIZE 256 /* FILE_NAME_SIZE + 1 */
#define C_SJIS_EUC_BIN "C:\\diyo-C\\MS932~EUC-JP.bin"
#define DATA_ARRAY_LIMIT 906
#define DO_NOT_SEARCH_TABLE "-d"
#define DOUBLE_KANJI 4 /* SJIS_KANJI_SIZE + EUC_KANJI_SIZE */
#define DUAL_KANJI 4 /* SJIS_KANJI_SIZE + SJIS_KANJI_SIZE */
#define ERROR_TEXT "error.txt"
#define EUC_KANJI_SIZE 2
#define EUC_KANJI_SIZE_1 3
#define FILE_NAME_SIZE 255
#define FIRST_KANJI 159
#define KANA_HANDAKUTEN 0xDF
#define KANA_KUTEN 0xA1
#define KANJI_SIZE 2
#define KATAKANA_SIZE 1
#define NORMAL_ARRAY_SIZE 3
#define RECORD_COUNT 7882
#define RIGHT_ARROW "" /* Shift_JIS */
#define SEARCH_COUNT 3
#define SETTING_TEXT "setting.txt"
#define SJIS_KANJI_SIZE 2
#define SJIS_EUC_BIN "MS932~EUC-JP.bin"
#define SUBSTITUTE_ARRAY_SIZE 3
#define WHICH_TABLE "-w"
#define ZERO "0"
#include "dividing.h"

typedef BOOL (*OPEN_CLOSE_FUNCTION)(char *buffer, int buffer_size);

typedef struct EUC_TABLE EUC_TABLE;
struct EUC_TABLE {
    char combo[4];
    char *table;
    int size;
};

typedef union KANJI KANJI;
union KANJI {
    unsigned char sequence[6];
    unsigned short code[3];
    unsigned int block;
};

typedef struct NORMAL_SUBSTITUTE NORMAL_SUBSTITUTE;
struct NORMAL_SUBSTITUTE {
    BOOL please_check;
    char normal[NORMAL_ARRAY_SIZE];
    char substitute[SUBSTITUTE_ARRAY_SIZE];
};

BOOL binary_file_in_current_directory(char *buffer, int buffer_size);
BOOL binary_file_in_installed_directory(char *buffer, int buffer_size);
BOOL binary_file_in_path_directory(char *buffer, int buffer_size);
BOOL edit_many_records(char *text, char *binary_name, BOOL no_searching, BOOL *which_table);
BOOL edit_record(char *normal, char *substitute, char *binary_name, BOOL no_searching, BOOL *which_table);
BOOL open_close(char *file_name);
BOOL setting(EUC_TABLE *u, BOOL no_searching, BOOL *which_table);
char *growing(EUC_TABLE *u, int index);
int inverted(char *c);
unsigned char working(EUC_TABLE *u, int index, int place);
void acquire_parameters_from_text(const char *parameters_text, char *binary_name, char *normal, char *substitute, char *text_of_substitutes_list, BOOL *no_searching, BOOL *which_table);
void clear_table(EUC_TABLE *u);
void detach_table(EUC_TABLE *u);
void error_handler(const char *p, const char *q);
void path_name(char *data, char *extra, char *buffer, int buffer_size);
void populated(EUC_TABLE *u, int index, int place, char c);
void version_guide(double v, BOOL comments);

#endif /* KANJI_UNION_H */
